% Lezione di lab  TTR  -17/05/2017- Tracking by Condensation- Marco Cristani

clear all;
clc;

%----------------------
% INIZIALIZZAZIONI
%----------------------

N       = 50 ; % numero particelle;
n_it    = 50   ; % iterazioni (= frames) del tracking;
loc_w   = 2   ; % larghezza della finestra d'osservazione;
dvst    = loc_w/3; % dev. standard per l'osservazione;

%% -- PARAMETRI MOTO -- %%
p_step        = 0.4  ;   % passo deterministico oggetto
p_noise       = 0.075 ;  


%% -- PARAMETRI MODELLO DINAMICO -- %%
diffu = 2; 
step = 0.2; % passo deterministico modello dinamica

%% -- PRIMO SAMPLING -- %%
real_posx               = 0.0; % POsizione reale dell'oggetto all'istante 1
real_posy               = 0.0; % POsizione reale dell'oggetto all'istante 1


for n=1:N
   s_old(n,1)            =  unifrnd(real_posx -3,real_posx +3) ;
   s_old(n,2)            =  unifrnd(real_posy -3,real_posy +3) ;
end;  
pi = ones(1,N)./N; 
c = cumsum(pi);



 h = figure; 
%----------------------
% CICLO PRINCIPALE
%----------------------

% %% -- EVOLUZIONE SISTEMA -- %%
for i=1:n_it
    
     real_posx    =   real_posx + p_step + p_noise * randn(1,1); % moto unif. + noise
     real_posy    =   real_posy + 2*sin(i/2) + p_noise * randn(1,1); % moto sinus.
     
     x(i,1)        =   real_posx;
     x(i,2)        =   real_posy;
     
    fprintf('t=%i|true pos. %2.2f,%2.2f \n',i,x(i,1),x(i,2));
    num_noise = round(unifrnd(1,5));
    sit(i).twoD =  [x(i,:);...
        [unifrnd(real_posx-10,real_posx+10,num_noise,1),...
        unifrnd(real_posy-10,real_posy+10,num_noise,1)];...
        mvnrnd([real_posx,real_posy],[0.01,0.002;0.002,0.01],3)];
    scatter(sit(i).twoD(1,1),sit(i).twoD(1,2),60,'rx'); hold on
    for j=2:size(sit(i).twoD,1)
        scatter(sit(i).twoD(j,1),sit(i).twoD(j,2),1,'ro');
    end

     
     % %% -- ESTRAZIONE E APPLICAZIONE DINAMICA -- %%
  for n=1:N
      ind     = pick_base_sample(N,c);
      s(n,1)     = s_old(ind,1) + step + diffu * randn(1,1);
      s(n,2)     = s_old(ind,2) + step + diffu * randn(1,1);%s_old(ind,2) +2*sin(i/2) + p_noise * randn(1,1);%
%       scatter(s(n,1),s(n,2),pi(n)*2000+1,'bo')
   end 

  for n=1:N
     mpi(n) = 0;
     for j =1:size(sit(i).twoD,1)
         if s(n,1)+loc_w>sit(i).twoD(j,1) & s(n,1)-loc_w<sit(i).twoD(j,1)&...
            s(n,2)+loc_w>sit(i).twoD(j,2) & s(n,2)-loc_w<sit(i).twoD(j,2) 
            mpi(n)= mpi(n)+mvnpdf([sit(i).twoD(j,:)]',[s(n,1);s(n,2)],[dvst,0;0,dvst]);
         end
     end
  end
  s_old = s;
 mpi = normalise(mpi);
 c = cumsum(mpi);
   for n=1:N
      scatter(s(n,1),s(n,2),mpi(n)*2000+1,'bo')
   end
 
   [thrash,max_ind]= max(mpi);
   pos_max(i,:)=s(max_ind,:);
   err_max(i)= norm(pos_max(i,:)-x(i,:));
   fprintf('Err MAP:%i \n\n',err_max(i));
   scatter(pos_max(i,1),pos_max(i,2),60,'go')
%     hold off
    
     pause
     
     
end




