% Lezione di lab  TTR  -17/05/2017- Tracking by Condensation- Marco Cristani

clear all;
clc;
warning off;
%----------------------
% INITIALIZATION
%----------------------
vidObj = VideoReader('videoTTR.avi');
C_info = aviinfo('videoTTR.avi');
C = read(vidObj,5);
figure; set(gcf,'name','Tracking'); subplot(211); imshow(C); title('Scene')  
[template, rect]=imcrop;
subplot(312); imagesc(template); axis on; title('Template')  
c = vidObj.Width;
r = vidObj.Height;
[rr,cc,ch] = size(template); 


N       = 100 ; % numero particelle;
n_it    = C_info.NumFrames   ; % length of my video;
loc_wr   = ceil(rr/2); % larghezza della finestra d'osservazione in x;
loc_wc   = ceil(cc/2); % larghezza della finestra d'osservazione in y;
% dvstr    = loc_wr/3; % dev. standard per l'osservazione in x;
% dvstc    = loc_wc/3; % dev. standard per l'osservazione in y;

% %% -- MOTION PARAMETERS -- %% I DO NOT HAVE THEM!!!
% p_step        = 0.4  ;   % passo deterministico oggetto
% p_noise       = 0.075 ;  


%% -- DYNAMICS MODEL -- %%
diffu = 40; 
step = 200; % deterministic step

%% -- FIRST SAMPLING -- %%
% real_posx               = 0.0; % POsizione reale dell'oggetto all'istante 1
% real_posy               = 0.0; % POsizione reale dell'oggetto all'istante 1

for n=1:N
   s_old(n,1)            =  unifrnd(loc_wr+1,r-loc_wr-1) ;
   s_old(n,2)            =  unifrnd(loc_wc+1,c-loc_wc-1) ;
end;  
pi = ones(1,N)./N; 
cu = cumsum(pi);

%----------------------
% CICLO PRINCIPALE
%----------------------

% %% -- EVOLUZIONE SISTEMA -- %%
for i=1:n_it
    C = rgb2gray(read(vidObj,i));
%      real_posx    =   real_posx + p_step + p_noise * randn(1,1); % moto unif. + noise
%      real_posy    =   real_posy + 2*sin(i/2) + p_noise * randn(1,1); % moto sinus.
     
%      x(i,1)        =   real_posx;
%      x(i,2)        =   real_posy;
     
%     fprintf('t=%i|true pos. %2.2f,%2.2f \n',i,x(i,1),x(i,2));
%     num_noise = round(unifrnd(1,5));
%     sit(i).twoD =  [...
%         [unifrnd(real_posx-10,real_posx+10,num_noise,1),...
%         unifrnd(real_posy-10,real_posy+10,num_noise,1)];...
%         mvnrnd([real_posx,real_posy],[0.01,0.002;0.002,0.01],3)];
%     scatter(sit(i).twoD(1,1),sit(i).twoD(1,2),60,'rx'); hold on
%     for j=2:size(sit(i).twoD,1)
%         scatter(sit(i).twoD(j,1),sit(i).twoD(j,2),1,'ro');
%     end

     
     % %% -- ESTRAZIONE E APPLICAZIONE DINAMICA -- %%
  for n=1:N
      ind     = pick_base_sample(N,cu);
      s(n,1)     = s_old(ind,1)  + diffu * randn(1,1);
      if s(n,1)<loc_wr+1; s(n,1)= loc_wr+1; end
      if s(n,1)>r-loc_wr-1; s(n,1)= r-loc_wr-1;  end  
      s(n,2)     = s_old(ind,2)  + diffu * randn(1,1);%s_old(ind,2) +2*sin(i/2) + p_noise * randn(1,1);%
%       scatter(s(n,1),s(n,2),pi(n)*2000+1,'bo')
      if s(n,2)<loc_wc+1; s(n,2)= loc_wc+1;end
      if s(n,2)>c-loc_wc-1; s(n,2)= c-loc_wc-1;end   
  end 
   subplot(311); imagesc(C); axis image; title('Scene');  hold on
% for n=1:N
%       scatter(s(n,1),s(n,2),40,'bo')
% end
  for n=1:N
      checkr=(round(s(n,1))-loc_wr):(round(s(n,1))+loc_wr);
      checkc=(round(s(n,2))-loc_wc):(round(s(n,2))+loc_wc);
      lik = normxcorr2(rgb2gray(template), C(checkr,checkc));
    
     mpi(n) = max(lik(:))^2;
%      for j =1:size(sit(i).twoD,1)
%          if s(n,1)+loc_w>sit(i).twoD(j,1) & s(n,1)-loc_w<sit(i).twoD(j,1)&...
%             s(n,2)+loc_w>sit(i).twoD(j,2) & s(n,2)-loc_w<sit(i).twoD(j,2) 
%             mpi(n)= mpi(n)+mvnpdf([sit(i).twoD(j,:)]',[s(n,1);s(n,2)],[dvst,0;0,dvst]);
%          end
%      end
  end
  s_old = s;
 mpi = normalise(mpi);
 cu = cumsum(mpi);
   for n=1:N
      scatter(s(n,2),s(n,1),mpi(n)*2000+1,'bo')
   end
 
   [thrash,max_ind]= max(mpi);
   pos_max(i,:)=s(max_ind,:);
   checkr=(round(s(max_ind,1))-loc_wr):(round(s(max_ind,1))+loc_wr);
   checkc=(round(s(max_ind,2))-loc_wc):(round(s(max_ind,2))+loc_wc);
%    err_max(i)= norm(pos_max(i,:)-x(i,:));
%    fprintf('Err MAP:%i \n\n',err_max(i));
    subplot(311); scatter(pos_max(i,2),pos_max(i,1),2000,'gx')
    subplot(313); imagesc(C(checkr,checkc));
    subplot(312); imagesc(template);
    hold off
   pause
     
     
end




